#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, epsabs, result, abserr, omega, *work;
    int neval, ier, integr, lst, *iwork;

 // a is the finite integration limit
    a = 0.0;

 // omega and integr determine the weight function
    omega = M_PI * 0.5;
    integr = 1;

 // epsabs is the requested absolute accuracy    
    epsabs = 0.001;

 // allocate memory
    iwork = (int *) calloc(LENIW, sizeof(int));
    work = (double *) calloc(LENW, sizeof(double));

    result = cquad_dqawf(fun, a, omega, integr, epsabs, &abserr, &neval, &ier, &lst, iwork, work);
 
 // print the result
    printf("\nFunction:  x-½ * cos(x/2)  over [0, +inf]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iwork);
    free(work);
}
