#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, epsabs, result, abserr, omega;
    double *alist, *blist, *rlist, *elist, *rslst, *erlst, **chebmo;
    int i, neval, ier, integr, lst, *iord, *nnlog, *ierlst;

 // a is the finite integration limit
    a = 0.0;

 // omega and integr determine the weight function
    omega = M_PI * 0.5;
    integr = 1;

 // epsabs is the requested absolute accuracy    
    epsabs = 0.001;

 // allocate memory
    iord = (int *) calloc(LIMIT, sizeof(int));
    ierlst = (int *) calloc(50, sizeof(int));
    nnlog = (int *) calloc(LIMIT, sizeof(int));
    alist = (double *) calloc(LIMIT, sizeof(double));
    blist = (double *) calloc(LIMIT, sizeof(double));
    rlist = (double *) calloc(LIMIT, sizeof(double));
    elist = (double *) calloc(LIMIT, sizeof(double));
    rslst = (double *) calloc(50, sizeof(double));
    erlst = (double *) calloc(50, sizeof(double));
    chebmo = (double **)calloc(MAXP1,sizeof(double *));
    for (i = 0; i < MAXP1; i++) 
       chebmo[i] = (double *)calloc(25,sizeof(double)); 

    result = cquad_dqawfe(fun, a, omega, integr, epsabs, &abserr, &neval, &ier, rslst, erlst, ierlst, &lst, alist, blist, rlist, elist, iord, nnlog, chebmo);

 // print the result
    printf("\nFunction:  x-½ * cos(x/2)  over [0, +inf]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);

 // free allocated memory 
    free(iord);
    free(ierlst);
    free(nnlog);
    free(alist);
    free(blist);
    free(rlist);
    free(elist);
    free(rslst);
    free(erlst);
    free(chebmo);
}
